/**
* This code was generated by v0 by Vercel.
* @see https://v0.dev/t/7vWDwqoza70
* Documentation: https://v0.dev/docs#integrating-generated-code-into-your-nextjs-app
*/

/** Add fonts into your Next.js project:

import { Inter } from 'next/font/google'

inter({
  subsets: ['latin'],
  display: 'swap',
})

To read more about using these font, please visit the Next.js documentation:
- App Directory: https://nextjs.org/docs/app/building-your-application/optimizing/fonts
- Pages Directory: https://nextjs.org/docs/pages/building-your-application/optimizing/fonts
**/
import { TooltipProvider, Tooltip, TooltipTrigger, TooltipContent } from "@/components/ui/tooltip"
import { Button } from "@/components/ui/button"
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome"
import { faClipboard, faClipboardCheck, faXmark } from '@fortawesome/free-solid-svg-icons'
import { useEffect, useState } from "react"

export function CopyToClipboardButton({
	data,
	onSuccess,
	onError,
}: {
	data: string,
	className?: string,
	onSuccess?: () => void,
	onError?: (error: unknown) => void,
}) {

	const [icon, setIcon] = useState(faClipboard);
	const [, setTimeoutID] = useState(null as number | null);


	useEffect(() => {
		if (icon.iconName === faClipboard.iconName) {
			return;
		}
		const tid = setTimeout(() => {
			setIcon(faClipboard);
		}, 1000) as unknown as number;
		setTimeoutID((old) => {
			if (old !== null) {
				clearTimeout(old);
			}
			return tid;
		});
	}, [icon]);

	return (
		<TooltipProvider>
			<Tooltip>
				<TooltipTrigger asChild>
					<Button
						variant="outline"
						type="button"
						size="icon"
						onClick={() => {
							navigator.clipboard.writeText(data).then(() => {
								if (onSuccess !== undefined) {
									onSuccess();
								}
								setIcon(faClipboardCheck);
							}).catch((error) => {
								setIcon(faXmark);
								console.error(error);
								if (onError !== undefined) {
									onError(error);
								}
							});
						}}
					>
						<FontAwesomeIcon icon={icon} className="h-4 w-4" />
						<span className="sr-only">Copy to clipboard</span>
					</Button>
				</TooltipTrigger>
				<TooltipContent>
					<p>Click to copy</p>
				</TooltipContent>
			</Tooltip>
		</TooltipProvider>
	)
}
